/* author GEKU 2019 */
/* v2.1 */

#include <stdio.h>
#include <wchar.h>
#include <string.h>
#include <stdlib.h>
#include "hidapi.h"
#include <unistd.h>

extern unsigned short pollcycle;
extern unsigned short vendor_id;
extern unsigned short product_id;

int init_sensor_loop(char *pPath);
int sensor_loop(char *pPath,unsigned char buf[256]);
void finish_sensor_loop(void);

int main(int argc, char *argv[])
{
    int res;
    unsigned char buf[256];
    hid_device *handle;
    if (init_sensor_loop(argv[0])) return 1;

    while (1)
    {
        if (hid_init()) return 2;
        handle = hid_open(vendor_id, product_id, NULL);

        if (!handle)
        {
            printf("unable to open device\r\n");
            return 3;
        }
        hid_set_nonblocking(handle, 1);
        memset(buf, 0, sizeof(buf));
        buf[0] = 0x7b;
        buf[1] = 0x03;
        buf[2] = 0x40;
        buf[3] = 0x7d;
        res = hid_write(handle, buf, 17);

        if (res < 0)
        {
            printf("Unable to write()\n");
            printf("Error: %ls\n", hid_error(handle));
        }
        res = 0;

        while (res == 0)
        {
            res = hid_read(handle, buf, sizeof(buf));
            //if (res == 0)
            //printf("waiting...\n");
            if (res < 0)
                printf("Unable to read()\n");
            sleep(1);
        }

        if (sensor_loop(argv[0],buf))
        {
            printf("error: sensor_loop\r\n");
            finish_sensor_loop();
            return 4;
        }

        hid_close(handle); // Free static HIDAPI objects
        hid_exit();
        sleep(pollcycle);
    }
    finish_sensor_loop();
    return 0;
}
