/* author GEKU 2019 */
/* v2.1 */

#include <stdio.h>
#include <wchar.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <libgen.h>
#include <wchar.h>
#include <sys/wait.h>
#include "iniparser.h"

dictionary *pINI;
char telegram[256];

const char **ppSensorEntries[8];
const char *pToken;
const char *pChat_id;
const char *pChat_id2;

int emoji;

unsigned short pollcycle;
unsigned short vendor_id;
unsigned short product_id;

short temp_diff;
short temp_max;
short temp_min;
short temp_val;
int test_sensor;

int old_temperature[8]={-2750,-2750,-2750,-2750,-2750,-2750,-2750,-2750};

const char *pUpEmoji[] =
{
    "",
    "\xF0\x9F\x94\xBC",
    "\xE2\xA4\xB4",
    "\xF0\x9F\x93\x88"
};

const char *pDnEmoji[] =
{
    "",
    "\xF0\x9F\x94\xBD",
    "\xE2\xA4\xB5",
    "\xF0\x9F\x93\x89"
};

int xchg2temp10(const char *px);
char *extract_word(unsigned char n, const char *pSrcStr, const char *pDelimiters, char *pDstStr);

void bot_chat(const char *pArgument1, const char *pArgument2)
{
    char mbuf[256];

    if (pChat_id)
    {
        sprintf(mbuf, "%s %s %s '%s %s'", telegram, pToken, pChat_id, pArgument1, pArgument2);
        system(mbuf);
    }

    if (pChat_id2)
    {
        sprintf(mbuf, "%s %s %s '%s %s'", telegram, pToken, pChat_id2, pArgument1, pArgument2);
        system(mbuf);
    }
}

int init_sensor_loop(char *pPath)
{
    int sensor;
    int entries;
    char path[256];

    sprintf(path, "%s/klima-server.ini", dirname(pPath));
    pINI = iniparser_load(path);

    if (pINI == NULL)
    {
        fprintf(stderr, "cannot parse file: %s\n", path);
        return -1;
    }

    pToken = iniparser_getstring(pINI, "BOT:token", NULL);
    pChat_id = iniparser_getstring(pINI, "BOT:chat_id", NULL);
    pChat_id2 = iniparser_getstring(pINI, "BOT:chat_id2", NULL);
    pollcycle = iniparser_getint(pINI, "SERVER:pollcycle", 60);
    vendor_id = iniparser_getint(pINI, "RS500:vendor_id", 0x0483);
    product_id = iniparser_getint(pINI, "RS500:product_id", 0x5750);

    emoji = iniparser_getint(pINI, "SERVER:emoji", 1) & 0x03;

    {
        const char *px;

        px = iniparser_getstring(pINI,"DEBUG:temp_diff","0");
        temp_diff = xchg2temp10(px);

        px = iniparser_getstring(pINI,"DEBUG:temp_max","0");
        temp_max = xchg2temp10(px);

        px = iniparser_getstring(pINI,"DEBUG:temp_min","0");
        temp_min = xchg2temp10(px);

        test_sensor= iniparser_getint(pINI,"DEBUG:sensor",-1);

        if (temp_diff>0)
        {
            temp_val=temp_min;
        }
        else
        {
            temp_val=temp_max;
        }
    }

    for (sensor=0;sensor<8;sensor++)
    {
        char snum[2];

        snum[1]=0;
        snum[0]=('0'+sensor);

        entries = iniparser_getsecnkeys(pINI,snum);

        if (entries)
        {
            ppSensorEntries[sensor] = malloc(sizeof(char *) * entries);
            ppSensorEntries[sensor] = iniparser_getseckeys(pINI,snum,ppSensorEntries[sensor]);
        }
    }

    {
        sprintf(path, "%s/telegram-send.sh", pPath);
        strcpy(telegram, path);
        bot_chat("KLIMA-SERVER", " gestartet");
    }
    return 0;
}

void finish_sensor_loop(void)
{
    if (pINI)
    {
        iniparser_freedict(pINI);
    }
}

int sensor_loop(char *pPath,unsigned char buf[256])
{
    int sensor;
    int entries;
    int xentry;
    char entry[16];
    const char *pName;

    for (sensor=0;sensor<8;sensor++)
    {
        char snum[2];
        snum[1]=0;
        snum[0]=('0'+sensor);

        entries = iniparser_getsecnkeys(pINI,snum);
        sprintf(entry, "%d:name", sensor);
        pName = iniparser_getstring(pINI, entry, NULL);

        if (entries && pName )
        {
            int new_temperature;
            // int new_humidity;
            // int old_humidity;

            if ((temp_diff) && (sensor==test_sensor))
            {
                new_temperature = temp_val;
            }
            else
            {
                new_temperature = (256 * buf[1 + 3 * sensor] + buf[2 + 3 * sensor]);
            }

            //new_humidity = buf[3 + 3 * sensor];
            sprintf(entry, "%d:temp10", sensor);

            if (abs(new_temperature - old_temperature[sensor]) > 2)
            {
                if (abs(new_temperature - old_temperature[sensor]) < 1000)
                {
                    if ((new_temperature - old_temperature[sensor]) > 0)
                    {
                        for (xentry=0;xentry<(entries-1);xentry++)
                        {
                            if (strstr(ppSensorEntries[sensor][xentry],":tu"))
                            {
                                const char *px;
                                char *py;
                                int value;
                                char tmpstr[64];

                                px = iniparser_getstring(pINI,ppSensorEntries[sensor][xentry],"-275");
                                value = xchg2temp10(extract_word(1,px,"|",tmpstr));

                                if ((value > old_temperature[sensor]) && (value <= new_temperature))
                                {
                                    char argument1[32];
                                    char argument2[64];
                                    char tmpstr1[64];

                                    sprintf(argument1, "*%s*", pName);
                                    py=extract_word(2,px,"|",tmpstr1);

                                    sprintf(argument2, "%0.1f°C  %s %s", (double) new_temperature / 10.0,pUpEmoji[emoji],py?py:"");
                                    bot_chat(argument1, argument2);

                                    old_temperature[sensor]=new_temperature;
                                }

                                if (py)
                                {
                                    char tmpstr1[64];
                                    char tmpstr2[64];
                                    char tmpstr3[256];

                                    py=extract_word(2,px,"|",tmpstr1);

                                    if (fork()==0) // child process because return value zero
                                    {
                                        char tmpstr3[64];
                                        char *argv[4] = {"Command-line",extract_word(2,py," ",tmpstr2),extract_word(3,py," ",tmpstr2),NULL};

                                        strcpy(tmpstr3,pPath);
                                        strcat(tmpstr3,"/");
                                        strcat(tmpstr3,extract_word(1,py," ",tmpstr2));
                                        execvp(tmpstr3,argv);
                                        fprintf(stderr,"ERROR: program %s not found!\n",tmpstr3);
                                        exit(1);
                                    }
                                }
                            }
                        }
                    }
                    else
                    {
                        for (xentry=entries-1;xentry>=0;xentry--)
                        {
                            if (strstr(ppSensorEntries[sensor][xentry],":td"))
                            {
                                const char *px;
                                char *py;
                                int value;
                                char tmpstr[64];

                                px = iniparser_getstring(pINI,ppSensorEntries[sensor][xentry],"-275");
                                value = xchg2temp10(extract_word(1,px,"|",tmpstr));

                                if ((value < old_temperature[sensor]) && (value >= new_temperature))
                                {
                                    char argument1[32];
                                    char argument2[64];
                                    char tmpstr1[64];

                                    sprintf(argument1, "*%s*", pName);
                                    py=extract_word(2,px,"|",tmpstr1);

                                    sprintf(argument2, "%0.1f°C  %s %s", (double) new_temperature / 10.0,pDnEmoji[emoji],py?py:"");
                                    bot_chat(argument1, argument2);

                                    old_temperature[sensor]=new_temperature;
                                }

                                if (py)
                                {
                                    char tmpstr1[64];
                                    char tmpstr2[64];
                                    char tmpstr3[256];

                                    py=extract_word(2,px,"|",tmpstr1);

                                    if (fork()==0) // child process because return value zero
                                    {
                                        char tmpstr3[64];
                                        char *argv[4] = {"Command-line",extract_word(2,py," ",tmpstr2),extract_word(3,py," ",tmpstr2),NULL};

                                        strcpy(tmpstr3,pPath);
                                        strcat(tmpstr3,"/");
                                        strcat(tmpstr3,extract_word(1,py," ",tmpstr2));
                                        execvp(tmpstr3,argv);
                                        fprintf(stderr,"ERROR: program %s not found!\n",tmpstr3);
                                        exit(1);
                                    }
                                }
                            }
                        }
                    }
                }
                else
                {
                    old_temperature[sensor]=new_temperature;
                }
            }
        }

        if ((temp_diff) && (sensor==test_sensor))
        {
            if ((temp_val <= temp_max) && (temp_val >= temp_min))
            {
                temp_val+=temp_diff;
            }
            else
            {
                bot_chat(pName, "Simulationsende!");
                temp_diff=0;
            }
        }
    }
    {
        int status;
        waitpid(-1, &status,  WNOHANG);
    }
    return 0;
}
